
package gus05.entity.gus.collection.support;

import java.util.List;
import java.util.Map;
import java.util.Set;

import gus05.framework.core.Entity;
import gus05.framework.features.Support;
import gus05.framework.features.Transform;


public class CollectionSupport implements Entity, Transform {

    
    public String getName()				{return "gus.collection.support";}
    public String getCreationDate()		{return "2006.07.07";}
    
    
    public Object transform(Object obj) throws Exception
    {
        if(obj instanceof Support) return obj;        
        
        if(obj instanceof Map)		return new Map1((Map)obj); 
        if(obj instanceof Set)		return new Set1((Set)obj);
        if(obj instanceof List)		return new List1((List)obj);
        
        throw new Exception("invalid type "+obj.getClass().getName());
    }

}
