/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.collection.support;

/**
 * @author gus
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.framework.tools.DefaultSupport;

import java.util.*;




class Map1 extends DefaultSupport implements Map, Retrieve, Register, Transform, Provide, Filter, Give {

	
	private Map map;
	
	private String keyName = null;
	private String valueName = null;
	
	private Class keyClass = null;
	private Class valueClass = null;
	
	
	private Object lastElement;
	private Object lastResult;
	private Object lastKey;
	
	
	
	
	
	public Map1(Map map)
	{this.map = map;}
	
	public Map1()
	{this(new Hashtable());}

	
	
	
	public Map getMap()
	{return map;}
	
	public Object getLastElement()
	{return lastElement;}
	
	public Object getLastResult()
	{return lastResult;}
	
	public Object getLastKey()
	{return lastKey;}
	
	
	
	
	
	
	public int size() 							{return map.size();}
	public boolean isEmpty() 					{return map.isEmpty();}
	public boolean containsKey(Object key) 		{return map.containsKey(key);}
	public boolean containsValue(Object value) 	{return map.containsValue(value);}
	public Set keySet()							{return map.keySet();}
	public Collection values()					{return map.values();}
	public Set entrySet() 						{return map.entrySet();}
	public Object get(Object key)				{return map.get(key);}
	public String toString()					{return map.toString();}
	public boolean equals(Object o)				{return map.equals(o);}
	
	
	
	public Object put(Object key, Object value)
	{
	    lastKey = key;
	    lastElement = value;
	    lastResult = map.put(key,value);
	    
	    send(this,"put(Object,Object)");
		return lastResult;
	}

	
	public Object remove(Object key)
	{
	    lastKey = key;
	    lastResult = map.remove(key);
	    
	    send(this,"remove(Object)");
		return lastResult;
	}
	

	public void putAll(Map m)
	{
	    map.putAll(m);
		send(this,"putAll(Map)");
	}

	
	public void clear()
	{
		map.clear();
		send(this,"clear()");
	}
    
    
    private void initMap(Map map)
    {
        this.map = map;
        send(this,"initMap(Map)");
    }
    
    
    
    


    public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastElement"))return lastElement;
        if(key.equals("lastResult"))return lastResult;
        if(key.equals("lastKey"))return lastKey;
        if(key.equals("map"))return map;
        
        if(key.equals("keyName"))return keyName;
        if(key.equals("valueName"))return valueName;
        if(key.equals("keyClass"))return keyClass;
        if(key.equals("valueClass"))return valueClass;
        
        if(key.equals("keys"))
            return new String[]{"lastElement","lastResult","lastKey","map","keyName","valueName","keyClass","valueClass"};
        
        throw new Exception("unknown key "+key);
    }


    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("keyName"))		{keyName = (String)obj;return;}
        if(key.equals("valueName"))		{valueName = (String)obj;return;}
        if(key.equals("keyClass"))		{keyClass = (Class)obj;return;}
        if(key.equals("valueClass"))	{valueClass = (Class)obj;return;}
        
        throw new Exception("unknown key "+key);
    }

    
    public boolean filter(Object obj) throws Exception 		{return map.containsKey(obj);}
    public Object transform(Object obj) throws Exception 	{return map.get(obj);}
    public Object provide() throws Exception 				{return map;}
    public void give(Object obj) throws Exception           {initMap((Map)obj);}
    
    
}
