package gus05.entity.gus.file.dirscan.gui.rootdirchooser;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Graphic;
import gus05.framework.tools.DefaultSupport;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;



public class RootDirChooser extends DefaultSupport implements Entity, Give, Provide, Graphic, ActionListener {


    public String getName()				{return "gus.file.dirscan.gui.rootdirchooser";}
    public String getCreationDate()		{return "2008.12.14";}


    private Service dirChooser;
    private Service form;
    
    private JPanel panel;
    private JButton button;




    public RootDirChooser() throws Exception
    {
    	dirChooser = Outside.service(this,"gus.file.label.load.dirlabel");
    	form = Outside.service(this,"gus.graphic.panel.form1");
    	
    	form.register("root folder: ",dirChooser.gui());
    	
    	button = new JButton("start scan");
    	button.addActionListener(this);
    	
        panel = new JPanel(new BorderLayout());
        panel.add(form.gui(),BorderLayout.CENTER);
        panel.add(button,BorderLayout.EAST);
    }



    public void give(Object obj) throws Exception
    {dirChooser.give(obj);}



    public JComponent gui()
    {return panel;}



    public Object provide() throws Exception
    {return dirChooser.provide();}


    
    public void actionPerformed(ActionEvent e)
	{start();}
    
    
    private void start()
	{send(this,"start()");}
}

