
package gus05.entity.gus.graphic.dnd;

import java.awt.datatransfer.DataFlavor;

import javax.swing.JComponent;
import javax.swing.JLabel;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;


public class Dnd implements Entity, Register, Graphic {

    public String getName()				{return "gus.graphic.dnd";}
    public String getCreationDate()		{return "2006.07.07";}

    
    private Service flavorProvider;
    private DataFlavor flavor;
    
    private Give give = null;
    private Provide provide = null;
    
    
    
    public Dnd() throws Exception
    {
        flavorProvider = Outside.service(this,"gus.graphic.dnd.flavor");
        flavor = (DataFlavor) flavorProvider.provide();
    }
    
    
    
    
    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("give"))
        {give = (Give)obj;return;}
        
        if(key.equals("provide"))
        {provide = (Provide)obj;return;}
        
        if(key.equals("comp"))
        {initTransfert((JComponent)obj);return;}
        
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    private void initTransfert(JComponent source)
    {new TransferHandler0(give,provide,source,flavor);}

    
    
    
    public JComponent gui()
    {
        JLabel label = new JLabel(" ");
        initTransfert(label);
        return label;
    }
}
