package gus05.entity.gus.graphic.filechooser.fileview;


import java.io.File;

import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileView;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class FileChooserFileView implements Entity, Give {


    public String getName()				{return "gus.graphic.filechooser.fileview";}
    public String getCreationDate()		{return "2008.02.27";}


    private Service fileIcon;

    public FileChooserFileView() throws Exception
    {
    	fileIcon = Outside.service(this,"gus.icondisplay.file1");
    }



    public void give(Object obj) throws Exception
    {
    	JFileChooser fc = (JFileChooser) obj;
    	fc.setFileView(new FileView0());
    }


    
    private Icon findIcon(File f)
    {
        try{return (Icon)fileIcon.transform(f);}
    	catch(Exception e)
    	{Outside.err(this,"findIcon(File)",e);}
		return null;
    }
    
    
    private class FileView0 extends FileView
    {	
    	public String getName(File f) {return null;}
        public String getDescription(File f) {return null;}
        public Boolean isTraversable(File f) {return null;}
        public Icon getIcon(File f) {return findIcon(f);}
    }
}

